## fwts 24.01.00

=== Makefile ===
#
# Copyright (C) 2021-2024 Canonical, Ltd.
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
#

KVER ?= `uname -r`
KBUILD_MODPOST_WARN=y
obj-m += smccc_test.o
all:
	make -C /lib/modules/$(KVER)/build M=`pwd` modules

install:
	make -C /lib/modules/$(KVER)/build M=`pwd` modules_install

clean:
	make -C /lib/modules/$(KVER)/build M=`pwd` clean

=== debian/changelog ===
fwts (24.01.00-0ubuntu4) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 05:29:27 +0000

fwts (24.01.00-0ubuntu3) noble; urgency=medium

  * Do not error on 'pointer-to-int-cast' warnings for now to fix build with
    _FILE_OFFSET_BITS=64 on 32-bit.

 -- Michael Hudson-Doyle <michael.hudson@ubuntu.com>  Fri, 22 Mar 2024 16:56:26 +1300

fwts (24.01.00-0ubuntu2) noble; urgency=medium

  * No-change rebuild against libglib2.0-0t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 08 Mar 2024 04:23:24 +0000

fwts (24.01.00-0ubuntu1) noble; urgency=medium

  [Armin Wolf]
  * acpi/wmi: Add WMI GUID for the dell-smm-hwmon driver
  * acpi/wmi: Warn if a WMI GUID has zero instances

  [Ivan Hu]
  * snapcraft: update the source repo for snap build
  * snapcraft: add source type for repo
  * lib: framework: clear the error message with the extra result filename
    suffix
  * snapcraft: specify devmode confinement for fwts snap
  * acpi: fadt: clarify the check for sleep control register
  * acpi: madt: fix typo of madt subnames
  * lib: fwts_acpi: add the PRM type GAS defined value
  * acpi: fadt: add PERSISTENT_CPU_CACHES bits to fixed feature flags
    (mantis 2206)
  * acpi: method: add _DSC method tests (mantis 2224)
  * fwts-test: method: sync up with adding _DSC method tests
  * acpi: srat: add new Generic Port structure for srat tests (mantis 2236)
  * fwts-test: sync up with new Generic Port structure added for srat
  * acpi: srat: fix to get device handle value and dump the reserved array
  * acpi: method: clarify TAD device methods requirements (mantis 2253)
  * lib: fwts_acpi_tables: add missing GAS address space ID
  * acpi: madt: add GICC new flag and length change (mantis 2285, 2303)
  * acpi: einj: test more error injection actions for einjv2 (mantis 2287)
  * acpi: method: fix typo of subelement
  * acpi: method: add _PDO test (mantis 2293)
  * fwts-test: sync up the method _PDO was added
  * acpi: phat: add reset reason health record test (mantis 2294)
  * fwts-test: sync up for reset reason health record test
  * acpi: viot: add test for ACPI VIOT table (mantis 2152)
  * fwts-test: add regression tests for VIOT
  * acpi: misc: add tests for ACPI MISC table (mantis 2297)
  * fwts-test: add regression tests for MISC
  * acpi: ccel: add tests for ACPI CCEL table (mantis 2314)
  * fwts-test: add regression tests for CCEL
  * acpi: viot: fix build fail on bionic and focal
  * acpi: skvl: add tests for ACPI SKVL table (mantis 2314)
  * fwts-test: add regression tests for SKVL
  * Update copyright year to 2024

  [Mario Limonciello]
  * Upgrade MCFGMMIONotReserved to HIGH error
  * s3: Add support for reading total s2idle residency from generic API
  * s3: Add support for checking last sleep cycle residency
  * Add support for ACPI 6.5 _UPC return values

 -- Ivan Hu <ivan.hu@ubuntu.com>  Mon, 22 Jan 2024 14:37:56 +0800

fwts (23.11.00-0ubuntu1) noble; urgency=medium

  [Armin Wolf]
  * acpi/wmi: Add WMI GUID for the wmi-bmof driver

  [Ivan Hu]
  * fwts-test: sync up with Recognize Pluton TPM patch
  * klog.json: Add some missing einj kernel messages to klog database
  * klog.json: Add some missing bert kernel messages to klog database
  * klog.json: Add some missing erst kernel messages to klog database
  * lib: fwts_acpi_table: fix fwts_acpi_reserved_zero_array with the input
    string
  * klog.json: Add some missing hest kernel messages to klog database
  * klog.json: Add some missing apmt kernel messages to klog database
  * klog.json: Add some missinig processor_perflib kernel messages to klog
    database
  * README: modify the fwts git repository
  * acpi: aspt: fix typo of SPTT
  * klog.json: Add some missing exresolv kernel messages to klog database
  * klog.json: Add some missing efi64 kernel messages to klog database
  * klog.json: Add some missing exmisc kernel messages to klog database
  * klog.json: Add some missing evmisc kernel messages to klog database
  * klog.json: Add some missing rslist kernel messages to klog database
  * klog.json: Add some missing exfield kernel messages to klog database
  * klog.json: Add some missing tbfadt kernel messages to klog database
  * klog.json: Add some missing hwregs kernel messages to klog database
  * klog.json: Add some missing exutils kernel messages to klog database
  * klog.json: Add some missing nsaccess kernel messages to klog database
  * klog.json: Add some missing bus kernel messages to klog database
  * klog.json: Add some missing battery kernel messages to klog database
  * klog.json: Add some missing power kernel messages to klog database
  * fwts-test: sync up the SPTT typo fix
  * fwts-test: sync up with the klog message update
  * acpi: ras2: add test for ACPI RAS2 table
  * fwts-test: add regression tests for RAS2
  * auto-packager: update the fwts git repo
  * lib: framework: fix the unclear error message of the results log
  * auto-packager: mkpackage.sh: add noble
  * acpi: ibft: add tests for iBFT table
  * fwts-test: add regression tests for iBFT

  [Mario Limonciello]
  * acpi: Recognize Pluton TPM

 -- Ivan Hu <ivan.hu@ubuntu.com>  Tue, 28 Nov 2023 15:30:05 +0800

fwts (23.09.00-0ubuntu1) mantic; urgency=medium

  [Arthur Heymans]
  * acpi/spcr: Update supported port types
  * acpi/scpr: spcr->interrupt_type == 0 is valid

  [Colin Ian King]
  * data/klog.json: Fix spelling mistakes found using codespell
  * src/*: Fix various spelling mistakes in source code

  [Ivan Hu]
  * fwts-test: sync up with klog.json ix spelling mistakes found using codespell
  * fwts-test: sync up with update supported port types
  * acpi: update fadt and madt revisions to ACPI 6.5
  * uefi: esrtdump: update the LastAttemptStatus values to UEFI spec 2.10
  * acpi: phat: fix the device path for the health data record
  * fwts-test: sync up with phat fix the device path for the health data record


=== debian/control ===
Source: fwts
Section: devel
Priority: optional
Rules-Requires-Root: no
Maintainer: Firmware Testing Team <fwts-devel@lists.ubuntu.com>
Uploaders: Ivan Hu <ivan.hu@canonical.com>
Standards-Version: 4.6.0
Homepage: https://wiki.ubuntu.com/FirmwareTestSuite
Build-Depends: debhelper-compat (= 13),
               autoconf,
               automake,
               libtool,
               flex,
               bison,
               dkms (<< 3.0.3-3~) | dh-sequence-dkms,
               libglib2.0-dev,
               pkg-config,
               libfdt-dev,
               libbsd-dev

Package: fwts
Architecture: i386 amd64 armel armhf arm64 ppc64 ppc64el s390x riscv64
Depends: libfwtsiasl1 (= ${binary:Version}),
         libfwtsacpica1 (= ${binary:Version}),
         libfwts1 (= ${binary:Version}),
         fwts-efi-runtime-dkms (= ${binary:Version}) [amd64],
         ${shlibs:Depends},
         ${misc:Depends},
         pciutils,
         device-tree-compiler [armel armhf arm64 ppc64el powerpc]
Suggests: dmidecode
Description: FirmWare Test Suite
 This is a firmware test suite that performs sanity checks on system
 firmware. It is intended to identify BIOS and ACPI errors and
 if appropriate it will try to explain the errors and give advice to
 help workaround or fix firmware bugs.  It is primarily intended to
 be a Linux-centric firmware troubleshooting tool.

Package: libfwtsiasl1
Architecture: i386 amd64 armel armhf arm64 ppc64 ppc64el s390x riscv64
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: FirmWare Test Suite ACPICA core built for iasl functionality
 The firmware test suite requires the ACPICA core engine to be built in
 compiler mode (with ACPI_ASL_COMPILER enabled) to support assembly and
 disassembly of ACPI Machine Language (AML) in the ACPI DSDT and SSDTs.
 This library contains this code with a thin fwts specific API to
 interface with fwts.

Package: libfwtsacpica1
Architecture: i386 amd64 armel armhf arm64 ppc64 ppc64el s390x riscv64
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: FirmWare Test Suite ACPICA core built for acpiexec functionality
 The firmware test suite requires the ACPICA core engine to be built in
 execution mode (with ACPI_EXEC_APP enabled) to support run time execution
 of ACPI Machine Language (AML) in the ACPI DSDT and SSDTs. This library
 contains this code with a thin fwts specific API to interface with fwts.

Package: libfwts1
Architecture: i386 amd64 armel armhf arm64 ppc64 ppc64el s390x riscv64
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: FirmWare Test Suite core support library
 This is the fwts core library. It contains a top level test framework
 and a rich range of firmware specific testing support code for the
 various fwts tests.

Package: fwts-frontend
Architecture: i386 amd64 armel armhf arm64 ppc64 ppc64el s390x riscv64
Priority: optional
Depends: ${misc:Depends},
         dialog,
         fwts
Description: Firmware Test Suite frontend interface
 This is a dialog based interface designed to provide an easy to use method
 to execute tests via Firmware Test Suite and is also used as the primary
 interface within Firmware Test Suite live images.

Package: fwts-efi-runtime-dkms
Architecture: i386 amd64 armel armhf arm64 ppc64 ppc64el
Priority: optional
Depends: ${misc:Depends},
         dkms
Description: Firmware Test Suite UEFI Runtime Service kernel driver
 This package provides the efi_runtime kernel driver in DKMS format,
 which is required for accessing UEFI Runtime Services.

Package: fwts-smccc-dkms
Architecture: arm64
Priority: optional
Depends: ${misc:Depends},
         dkms
Description: Firmware Test Suite SMCCC firmware kernel driver
 This package provides the ARM64 SMCCC kernel driver in DKMS format,
 which is required for accessing the ARM64 SMCCC firmware API.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS=hardening=+all
export DEB_CFLAGS_MAINT_APPEND=-Wno-error=pointer-to-int-cast

DEBVERS := $(shell dpkg-parsechangelog | grep ^Version: | cut -d' ' -f2 \
		| cut -d- -f1)

VERSION := $(shell echo '$(DEBVERS)' | sed -e 's/[+-].*//' -e 's/~//g')

DKMS_EFI_RUNTIME_SRC_DIR := $(CURDIR)/debian/fwts-efi-runtime-dkms/usr/src/fwts-efi-runtime-dkms-$(VERSION)
DKMS_SMCCC_SRC_DIR := $(CURDIR)/debian/fwts-smccc-dkms/usr/src/fwts-smccc-dkms-$(VERSION)

override_dh_auto_install:
	install -d $(DKMS_EFI_RUNTIME_SRC_DIR)
	cp -a efi_runtime/* $(DKMS_EFI_RUNTIME_SRC_DIR)
	install -d $(DKMS_SMCCC_SRC_DIR)
	cp -a smccc_test/* $(DKMS_SMCCC_SRC_DIR)
	dh_auto_install

override_dh_dkms:
	dh_dkms -V $(VERSION)

override_dh_auto_test:
ifneq ($(DEB_BUILD_ARCH),arm64)
	dh_auto_test $@
endif

%:
	dh $@ --with autoreconf,dkms

## fwts 24.07.00

=== debian/changelog ===
fwts (24.07.00-0ubuntu1) oracular; urgency=medium

  [Ivan Hu]
  * autopackager: mkpackage.sh: remove lunar
  * lib: fwts_log_html: fix the invalid printf format string
  * auto-packer: mkpackage.sh: add oracular
  * efi_runtime: don't build dkms module for those kernels with efi_test
  * acpi: cedt: add raw data dump for interleave target list
  * fwts-test: cedt: fix the wrong value of ENIW
  * fwts-test: cedt: sync up with adding raw data dump
  * acpi: s3pt: add tests for ACPI S3PT table
  * fwts-test: add regression tests for S3PT
  * acpi: acpipld: modify the test description to aviod misunderstanding
  * auto-packager: mkpackage.sh: remove mantic

  [Jonathan McDowell]
  * tpmevlog: Ensure EV_SEPARATOR recorded for PCRs 0-7

  [Julien Olivain]
  * libfwtsiasl: fix parallel build with GNU Make >= 4.4

  [Mario Limonciello]
  * aspm: Only require ASPM for devices with an actual link

 -- Ivan Hu <ivan.hu@ubuntu.com>  Tue, 30 Jul 2024 11:10:40 +0800

fwts (24.03.00-0ubuntu1) noble; urgency=medium

  [Colin Ian King]
  * ACPICA: Update to version 20240322

  [Ivan Hu]
  * acpi: s3: enable debug messages on S0ix failure for Intel platforms
  * acpi: s3: fix potential memory leaks on fwts_get() calls
  * framework: fix memory leaks caused by fwts_log_get_filenames
  * acpi: ras2: stop for loop when list exceeds the table
  * acpi: dbg2: update the subtype RISC-V SBI console for DBG2
  * acpi: sbbr: check the existence of SPCR console devices
  * opal: fix the resource leak for get_linux_mem_devices
  * acpi: srat: fix the untrusted loop bound warning
  * opal: fix the resource leak for process_dimm and process_mba
  * opal: fix the resource leak for cpus
  * acpi: acpipld: add tests to check _PLD methods only on the connectable ports
  * lib: fwts_acpi_tables: fix the build fail on armhf

  [Mario Limonciello]
  * dmicheck: Don't check firmware version on anything but NVDIMM devices

 -- Ivan Hu <ivan.hu@ubuntu.com>  Mon, 08 Apr 2024 11:20:06 +0800

## fwts 24.11.00

=== debian/changelog ===
fwts (24.11.00-0ubuntu1) plucky; urgency=medium

  [Armin Wolf]
  * lib: fwts_acpi_object_eval: Do not return FWTS_OK if method lookup fails
  * acpi/wmi: Warn if WMI GUIDs from the Windows driver samples are found

  [Colin Ian King]
  * src/acpi: Fix a few spelling mistakes

  [Ivan Hu]
  * dmicheck: update for supporting DMI version to 3.7.1
  * script: fix bash-completion-with-hashbang lintian warning
  * dmicheck: update for supporting DMI version to 3.8.0
  * dmicheck: add more types for version length test.
  * auto-packager: mkpackage.sh: add plucky
  * hdaaudio: fix the the build errors under plucky amd64

  [Jonathan McDowell]
  * tpmevlog: Ensure the event log matches the actual TPM PCRs

  [Simon Wang]
  * acpi: iort: memory access flag update.

 -- Ivan Hu <ivan.hu@ubuntu.com>  Tue, 26 Nov 2024 14:11:09 +0800

fwts (24.09.00-0ubuntu1) oracular; urgency=medium

  [Colin Ian King]
  * ACPICA: Update to version 20240827
  * fwts-test: slic: sync test results with fixes to ACPICA SLIC dumping

  [Ivan Hu]
  * configure.ac: fix the autoreconf AC_PROG_LIBTOOL warning
  * configure.ac: fix the autoreconf AC_PROG_LEX warning
  * acpi: acpipld: downgrade the severity for PLD on the not connected port
  * klog: fix the pattern errors for einj trigger table entry
  * klog.json: Add some missing agdi kernel messages to klog database
  * klog.json: Add some missing ghes kernel messages to klog database
  * klog.json: Add some missing gtdt kernel messages to klog database
  * klog.json: Add more missing iort kernel messages to klog database
  * lib: modprobe: add checking the compressed zst module format
  * klog.json: Add more missing osl kernel messages to klog database
  * klog.json: Add more missing acpi pcc kernel messages to klog database
  * klog.json: Add the missing fan_core error message to klog database
  * klog.json: Add the missing ipmi error messages to klog database
  * klog.json: Add the missing viot error messages to klog database
  * klog.json: Add the missing prmt error messages to klog database
  * klog.json: Add the missing scan error messages to klog database
  * klog.json: Add more error messages for battery to klog database
  * klog.json: Add the missing srat error message to klog database
  * klog.json: Add more uttrack error messages to klog database
  * klog.json: Add more utobject error messages to klog database
  * klog.json: Add more nsxfeval error messages to klog database
  * klog.json: Add the missing exstore error message to klog database
  * klog.json: Add the missing nsinit error message to klog database
  * klog.json: Add the missing dswload2 error message to klog database
  * klog.json: Add the missing exoparg2 error message to klog database
  * klog.json: Add the missing exserial error message to klog database
  * klog.json: Add the missing exreqion error message to klog database
  * klog.json: Add the missing processor error message to klog database

 -- Ivan Hu <ivan.hu@ubuntu.com>  Tue, 24 Sep 2024 12:42:57 +0800

## fwts 25.01.00

=== Makefile ===
--- 
+++ 
@@ -1,5 +1,5 @@
 #
-# Copyright (C) 2021-2024 Canonical, Ltd.
+# Copyright (C) 2012-2025 Canonical, Ltd.
 #
 # This program is free software; you can redistribute it and/or
 # modify it under the terms of the GNU General Public License
@@ -18,7 +18,7 @@
 
 KVER ?= `uname -r`
 KBUILD_MODPOST_WARN=y
-obj-m += smccc_test.o
+obj-m += efi_runtime.o
 all:
 	make -C /lib/modules/$(KVER)/build M=`pwd` modules

=== debian/changelog ===
fwts (25.01.00-0ubuntu1) plucky; urgency=medium

  [Armin Wolf] 
  * acpi/wmi: Stop directing users to outdated LWN article

  [Colin Ian King]
  * ACPICA: Update to version 20241212

  [Hector Cao]
  * acpi/s3 : fix stack smashing crash for s3 test

  [Ivan Hu]
  * dmicheck: fix the wrong size check for type 4
  * acpi: uniqueid: fix the uniqueid test for the CID with package
  * acpitables: update ACPI table revsion test to ACPI 6.5
  * Update copyright year to 2025
  * acpi: s3: reading residencyslp_s0_residency_usec for intel platforms
  * dmicheck: check the config files exist for CONFIG_STRICT_DEVMEM setting

  [Mario Limonciell]o
  * acpi: acpitables: Correct PCCT revision for ACPI 6.2

 -- Ivan Hu <ivan.hu@ubuntu.com>  Tue, 21 Jan 2025 11:18:25 +0800

## fwts 25.05.00

=== debian/changelog ===
fwts (25.05.00-0ubuntu1) questing; urgency=medium

  [Colin Ian King]
  * ACPICA: Update to version 20250404

  [Gergo Koteles]
  * acpi: method: Fix _DDC test arguments

  [Heinrich Schuchardt]
  * lib/fwts_cpu: correct determination of SEV enablement
  * fwts.h: fix typo verision

  [Ivan Hu]
  * efi_runtime: Fix missing pending status update in getwakeuptime
  * aspm: fix dereference pointer rp_cap before null check
  * opal: fix the unexpected line format
  * kernelscan: fix structurally unreachable code
  * lib: fwts_log: fix the potential overflow for dumping all log fields
  * lib: fwts_memorymap: fix the unchecked end address for strtoull
  * lib: fwts_memorymap: fix failure to retrieve BIOS memory map from dmesg e820
  * autobrightness: fix calloc argument order for GCC 15 compatibility
  * auto-packager: mkpackage.sh: add questing
  * dmicheck: add total size read checking below maximum allowed

  [Mario Limonciello]
  * cpu/msr: Drop `VM_HSAVE_PA` from consistency checks

  [monty.zhao]
  * acpi: madt: fix false FAIL on missing GICC UID for disabled CPUs

 -- Ivan Hu <ivan.hu@ubuntu.com>  Tue, 27 May 2025 10:16:04 +0800

fwts (25.03.00-0ubuntu1) plucky; urgency=medium

  [Ivan Hu]
  * acpi: cedt: update the cedt tests for CXL spec rev3.2
  * fwts-test: cedt: sync up tests with CEDT version update
  * acpi: apmt: add tests for acpi APMT table
  * fwts-test: add regression tests for APMT
  * klog.json: Add the thread create failed message to klog database
  * klog.json: Add more spcr access width messages to klog database
  * klog.json: Add more cppc checking and sending messages to klog database
  * klog.json: Add more intel pmic messages to klog database
  * klog.json: Add nfit intel messages to klog database
  * klog.json: Add ACPI fpdt messages to klog database
  * klog.json: Add EC timeout messages to klog database
  * klog.json: Add null object pushing message to klog database
  * klog.json: Add child missing data message to klog database
  * klog.json: Add package init messages to klog database
  * klog.json: Add more ownerid allocate and release messages to klog database
  * klog.json: Add the object type for evaluation messages to klog database
  * klog.json: Add more parse mode setting messages to klog database
  * efi_runtime: remove no_llseek which have been removed on kernel 6.12

 -- Ivan Hu <ivan.hu@ubuntu.com>  Wed, 26 Mar 2025 11:06:43 +0800

## fwts 25.07.00

=== Makefile ===
--- 
+++ 
@@ -1,5 +1,5 @@
 #
-# Copyright (C) 2012-2025 Canonical, Ltd.
+# Copyright (C) 2021-2025 Canonical, Ltd.
 #
 # This program is free software; you can redistribute it and/or
 # modify it under the terms of the GNU General Public License
@@ -18,7 +18,7 @@
 
 KVER ?= `uname -r`
 KBUILD_MODPOST_WARN=y
-obj-m += efi_runtime.o
+obj-m += smccc_test.o
 all:
 	make -C /lib/modules/$(KVER)/build M=`pwd` modules

=== debian/control ===
--- 
+++ 
@@ -19,7 +19,7 @@
                libbsd-dev
 
 Package: fwts
-Architecture: i386 amd64 armel armhf arm64 ppc64 ppc64el s390x riscv64
+Architecture: i386 amd64 armel armhf arm64 ppc64 ppc64el s390x riscv64 loong64
 Depends: libfwtsiasl1 (= ${binary:Version}),
          libfwtsacpica1 (= ${binary:Version}),
          libfwts1 (= ${binary:Version}),
@@ -37,7 +37,7 @@
  be a Linux-centric firmware troubleshooting tool.
 
 Package: libfwtsiasl1
-Architecture: i386 amd64 armel armhf arm64 ppc64 ppc64el s390x riscv64
+Architecture: i386 amd64 armel armhf arm64 ppc64 ppc64el s390x riscv64 loong64
 Depends: ${shlibs:Depends},
          ${misc:Depends}
 Description: FirmWare Test Suite ACPICA core built for iasl functionality
@@ -48,7 +48,7 @@
  interface with fwts.
 
 Package: libfwtsacpica1
-Architecture: i386 amd64 armel armhf arm64 ppc64 ppc64el s390x riscv64
+Architecture: i386 amd64 armel armhf arm64 ppc64 ppc64el s390x riscv64 loong64
 Depends: ${shlibs:Depends},
          ${misc:Depends}
 Description: FirmWare Test Suite ACPICA core built for acpiexec functionality
@@ -58,7 +58,7 @@
  contains this code with a thin fwts specific API to interface with fwts.
 
 Package: libfwts1
-Architecture: i386 amd64 armel armhf arm64 ppc64 ppc64el s390x riscv64
+Architecture: i386 amd64 armel armhf arm64 ppc64 ppc64el s390x riscv64 loong64
 Depends: ${shlibs:Depends},
          ${misc:Depends}
 Description: FirmWare Test Suite core support library
@@ -67,7 +67,7 @@
  various fwts tests.
 
 Package: fwts-frontend
-Architecture: i386 amd64 armel armhf arm64 ppc64 ppc64el s390x riscv64
+Architecture: i386 amd64 armel armhf arm64 ppc64 ppc64el s390x riscv64 loong64
 Priority: optional
 Depends: ${misc:Depends},
          dialog,
@@ -78,7 +78,7 @@
  interface within Firmware Test Suite live images.
 
 Package: fwts-efi-runtime-dkms
-Architecture: i386 amd64 armel armhf arm64 ppc64 ppc64el
+Architecture: i386 amd64 armel armhf arm64 ppc64 ppc64el loong64
 Priority: optional
 Depends: ${misc:Depends},
          dkms

## fwts 26.01.00

=== smccc_test/Makefile ===
#
# Copyright (C) 2021-2026 Canonical, Ltd.
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
#

KVER ?= `uname -r`
KBUILD_MODPOST_WARN=y
obj-m += smccc_test.o
all:
	make -C /lib/modules/$(KVER)/build M=`pwd` modules

install:
	make -C /lib/modules/$(KVER)/build M=`pwd` modules_install

clean:
	make -C /lib/modules/$(KVER)/build M=`pwd` clean

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS=hardening=+all

DEBVERS := $(shell dpkg-parsechangelog | grep ^Version: | cut -d' ' -f2 \
		| cut -d- -f1)

VERSION := $(shell echo '$(DEBVERS)' | sed -e 's/[+-].*//' -e 's/~//g')

DKMS_SMCCC_SRC_DIR := $(CURDIR)/debian/fwts-smccc-dkms/usr/src/fwts-smccc-dkms-$(VERSION)

override_dh_auto_install:
	install -d $(DKMS_SMCCC_SRC_DIR)
	cp -a smccc_test/* $(DKMS_SMCCC_SRC_DIR)
	dh_auto_install

override_dh_dkms:
	dh_dkms -V $(VERSION)

override_dh_auto_test:
ifneq ($(DEB_BUILD_ARCH),arm64)
	dh_auto_test $@
endif

%:
	dh $@ --with autoreconf,dkms
